function browser_GetBrowserInfo( )
{
   this.CodeName    = navigator.appCodeName ;
   this.UserAgent   = navigator.userAgent   ;
   this.BrowserName = navigator.appName     ;
   this.VersionStr  = navigator.appVersion  ;
   this.Platform    = navigator.platform    ;


   browser_ExtractBrowser( this ) ;
   browser_ExtractVersion( this ) ;

   return this ;

}

function browser_ExtractBrowser( b )
{
   b.fNS         = ( b.BrowserName == "Netscape"           &&
                     b.UserAgent.indexOf("Opera")    == -1 && 
                     b.UserAgent.indexOf("Netscape") != -1
                   );
                   
   b.fFirefox     = ( b.UserAgent.indexOf("Firefox")   != -1 ) ;
   
   b.fIE         = ( b.BrowserName == "Microsoft Internet Explorer" &&
                     b.UserAgent.indexOf("MSIE")    != -1           &&
                     b.UserAgent.indexOf("Opera")   == -1           
                   );

   b.fOpera      = ( b.UserAgent.indexOf("Opera") != -1  ) ;

   b.fMozilla    = ( b.UserAgent.indexOf("Mozilla")   != -1 && 
                     b.UserAgent.indexOf("Gecko")     != -1 &&
                     b.UserAgent.indexOf("Konqueror") == -1 && 
                     b.UserAgent.indexOf("Safari")    == -1 &&
                     b.UserAgent.indexOf("Firefox")   == -1 &&                       
                     b.UserAgent.indexOf("MSIE")      == -1 &&
                     b.UserAgent.indexOf("Netscape")  == -1 &&                   
                     b.UserAgent.indexOf("OmniWeb" )  == -1 
                     ) ;
                     
   b.fSafari     = ( b.UserAgent.indexOf("Safari")   != -1 ) ;

   b.fOmniWeb    = ( b.UserAgent.indexOf("OmniWeb")  != -1 ) ;

   b.fKonqueror  = ( b.BrowserName == "Konqueror" ) ;
}

function browser_ExtractVersion( b )
{  
   var strs, str ;

   b.VersionNum  = 0.0 ;

   if( b.fIE  &&
       b.VersionStr.indexOf("MSIE") != -1 ){ 

      strs = b.VersionStr.split("MSIE") ;
      b.VersionNum = parseFloat( strs[1] ) ;
   }
   if( b.fNS  &&
       b.UserAgent.indexOf("Netscape") != -1 ){ 

      strs = b.UserAgent.split("Netscape") ;
      b.VersionNum = parseFloat( strs[ 1 ].substr( 1 ) ) ;
   }

   if( b.fOpera &&
       b.UserAgent.indexOf("Opera") != -1 ) {

      strs = b.UserAgent.split("Opera") ;
      b.VersionNum = parseFloat( strs[ 1 ].substr( 1 ) ) ;
   }

   if( b.fMozilla ){

      strs = b.UserAgent.split("rv:") ;
      b.VersionNum = parseFloat( strs[ 1 ] ) ;
   }
   if( b.fFirefox){
	   strs = b.UserAgent.split("Firefox") ;
	   b.VersionNum = parseFloat( strs[ 1 ] ) ;
   }

   if( b.fSafari ){

      strs = b.UserAgent.split("Safari") ;
      b.VersionNum = parseFloat( strs[ 1 ].substr( 1 )  ) ;
   }

   if( b.fOmniWeb ){

      strs = b.UserAgent.split("OmniWeb") ;
      b.VersionNum = parseFloat( strs[ 1 ].substr( 2 ) ) ;
   }

   if( b.fKonqueror ){

      strs = b.UserAgent.split("Konqueror") ;
      b.VersionNum = parseFloat( strs[ 1 ] ) ;
   }
}

function browser_DisplayInfo( b )
{
   var str = "";
   
   str += "Browser Detected : " ;

   if( b.fIE        ) str += "Internet Explorer " ;
   if( b.fFirefox	) str += "Firefox " ;
   if( b.fNS        ) str += "Netscape ";
   if( b.fOpera     ) str += "Opera "   ;
   if( b.fMozilla   ) str += "Mozilla " ;
   if( b.fSafari    ) str += "Safari "  ;
   if( b.fOmniWeb   ) str += "OmniWeb " ;
   if( b.fKonqueror ) str += "Konqueror " ;

   str += b.VersionNum + "\n";

   str += "Platform : " + b.Platform    + "\n" ;

   alert( str ) ;
}

function browser_ResizeWindow( doc_resize_width, doc_resize_height, flag_center )
{
   var browser = new browser_GetBrowserInfo( ) ;

   var doc_resize_adjust_width  = 0 ;
   var doc_resize_adjust_height = 0 ;


   if( browser.fIE && browser.Platform == "Win32" ){ 
      doc_resize_adjust_height = -5;
   }
   
   if( browser.fKonqueror ) {
      /* note: width of 6 works for suse linux but is 
               not enough for redhat - but there is no
               way to tell them apart.
      */
      doc_resize_adjust_width  = 17;
      doc_resize_adjust_height = 34;
   }
   if( browser.fFirefox ){
	  doc_resize_adjust_width  = 1;
	  doc_resize_adjust_height = 0;
   }
   if( browser.fSafari ){
      doc_resize_adjust_width  = 5;
      doc_resize_adjust_height = 5;
   }

   if( browser.fMozilla ) {
      doc_resize_adjust_width = 2;
      doc_resize_adjust_height = 3;
   }

   doc_resize_width  += doc_resize_adjust_width  ;
   doc_resize_height += doc_resize_adjust_height ;
       
   if( window == null ){
	return;
   }

   if( window.resizeTo == null ){
	return;
   }

   window.resizeTo( doc_resize_width, doc_resize_height ) ;

   if( flag_center        &&
       screen.availWidth  &&
       screen.availHeight ){ 

      if( !browser.fOpera ) {

         window.moveTo( ( ( screen.availWidth  - doc_resize_width  ) / 2 ), 
                        ( ( screen.availHeight - doc_resize_height ) / 2 ) ); 
      } else {

         /* opera contains everything within one window whoes size
            does not correspond to the available pixels screen values... 
            so the window would end up way off visible region
         */
         window.moveTo( 10, 10 ); 
         
      }
   }
}